    /* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "`$INSTANCE_NAME`.h"

#include <project.h>
//#include <stdlib.h>
//#include <sine10.h> // 10-bit sine table

//#define BlinkLED(); {Pin_LED_Write(1); CyDelayUs(30); Pin_LED_Write(0);} // blink LED indicator

static
uint8 * pBuffer = `$INSTANCE_NAME`_Buffer;  //ok  
//uint8 * `$INSTANCE_NAME`_Buffer_PTR = (&`$INSTANCE_NAME`_Buffer[0]);?


// local variables 
//uint16 Num_of_Imp = `$INSTANCE_NAME`_Num_of_Imp; 				// Читаем коэффициент умножения импульсов 
//uint32 counter_overflow = `$INSTANCE_NAME`_counter_overflow;	// время максимальногоожидания прихода сигнала

static
uint8 aInitialized = 0; // initialized
static
uint8 aEnabled = 0;     // started (enabled)?



//==============================================================================
// DMA Configuration for VDAC
//==============================================================================

void `$INSTANCE_NAME`_DMAConfig(void)
{
    
    // Variable declarations for DMA2
    //uint8_t DMA_Chan;
    //uint8_t DMA_TD[2];
    
    #define TRANSFER_COUNT1 (`$INSTANCE_NAME`_NumRefHigh)
    #define TRANSFER_COUNT2 (`$INSTANCE_NAME`_NumSamples - `$INSTANCE_NAME`_NumRefHigh)
    
    #define DMA_BYTES_PER_BURST     (1u)
    #define DMA_REQUEST_PER_BURST   (1u)
    //#define DMA_SRC_BASE (&Buffer2[0]) - correct 
    //#define DMA_SRC_BASE (&Buffer2[200])
    #define DMA_SRC_BASE_ (pBuffer) // todo
    #define DMA_DST_BASE (CYDEV_PERIPH_BASE)
    
    DMA_Chan = `$INSTANCE_NAME`_DMA2_DmaInitialize(DMA_BYTES_PER_BURST, DMA_REQUEST_PER_BURST, HI16(DMA_SRC_BASE_), HI16(DMA_DST_BASE));
    DMA_TD[0] = CyDmaTdAllocate();
	DMA_TD[1] = CyDmaTdAllocate();
    
    //CyDmaTdSetConfiguration(DMA_TD[0], TRANSFER_COUNT1, DMA_TD[1], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
	//CyDmaTdSetConfiguration(DMA_TD[1], TRANSFER_COUNT2, DMA_TD[0], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
	#if `$INSTANCE_NAME`_SingleShot // execute once 
        CyDmaTdSetConfiguration(DMA_TD[0], TRANSFER_COUNT1, DMA_TD[1], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
        CyDmaTdSetConfiguration(DMA_TD[1], TRANSFER_COUNT2, CY_DMA_DISABLE_TD, TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN); // single run
    #else                           // continuous operation
        CyDmaTdSetConfiguration(DMA_TD[0], TRANSFER_COUNT1, DMA_TD[1], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
    	CyDmaTdSetConfiguration(DMA_TD[1], TRANSFER_COUNT2, DMA_TD[0], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
    #endif
    
    // Target 
    //CyDmaTdSetAddress(DMA_TD[0], LO16((uint32)&`$INSTANCE_NAME`_Buffer[0])              , LO16((uint32)`$INSTANCE_NAME`_Data_PTR));
	//CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&`$INSTANCE_NAME`_Buffer[TRANSFER_COUNT1]), LO16((uint32)`$INSTANCE_NAME`_Data_PTR));
    CyDmaTdSetAddress(DMA_TD[0], LO16((uint32)&`$INSTANCE_NAME`_Buffer[0])              , LO16((uint32)`$INSTANCE_NAME`_Target_PTR));
	CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&`$INSTANCE_NAME`_Buffer[TRANSFER_COUNT1]), LO16((uint32)`$INSTANCE_NAME`_Target_PTR));

    // moved to _Enable()
    //CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);
    //CyDmaChEnable(DMA_Chan, 1);    // Enable DMA2 channel 
}    


//==============================================================================
// DMA Configuration
//==============================================================================
/*
void `$INSTANCE_NAME`_DMAConfigEx(uint8 value)
{
    // Variable declarations for DMA2
    //uint8_t DMA_Chan;
    //uint8_t DMA_TD[2];
    
    //#define TRANSFER_COUNT1 (`$INSTANCE_NAME`_NumRefHigh)
    //#define TRANSFER_COUNT2 (`$INSTANCE_NAME`_NumSamples - `$INSTANCE_NAME`_NumRefHigh)

    if (value==0) value=1; else if (value>=`$INSTANCE_NAME`_NumSamples) value = `$INSTANCE_NAME`_NumSamples - 1; // trim

    #define TRANSFER_COUNT1a (value)
    #define TRANSFER_COUNT2a (`$INSTANCE_NAME`_NumSamples - value)

    
    //CyDmaChDisable(DMA_Chan);    // Disable DMA2 channel 
    //CyDmaChFree(DMA_Chan);
    //CyDmaClearPendingDrq(DMA_Chan);

    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    //#define DMA_BYTES_PER_BURST     (1u)
    //#define DMA_REQUEST_PER_BURST   (1u)
    #define DMA_SRC_BASE_1 (`$INSTANCE_NAME`_Buffer[0])
    #define DMA_SRC_BASE_2 (`$INSTANCE_NAME`_Buffer[TRANSFER_COUNT1a])
    //#define DMA_DST_BASE (CYDEV_PERIPH_BASE)
    
    //DMA_Chan = `$INSTANCE_NAME`_DMA2_DmaInitialize(DMA_BYTES_PER_BURST, DMA_REQUEST_PER_BURST, HI16(DMA_SRC_BASE), HI16(DMA_DST_BASE));
    //DMA_TD[0] = CyDmaTdAllocate();
	//DMA_TD[1] = CyDmaTdAllocate();
    
    
    CyDmaTdSetConfiguration(DMA_TD[0], TRANSFER_COUNT1a, DMA_TD[1], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
	CyDmaTdSetConfiguration(DMA_TD[1], TRANSFER_COUNT2a, DMA_TD[0], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
    
    
    //#if `$INSTANCE_NAME`_OUTP_DIGITAL_BUS
    //    CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&DMA_SRC_BASE_2) , LO16((uint32)`$INSTANCE_NAME`_ControlReg_Control_PTR));
    //#else
    //    ///CyDmaTdSetAddress(DMA_TD[0], LO16((uint32)&DMA_SRC_BASE1) , LO16((uint32)`$INSTANCE_NAME`_VDAC_Data_PTR));
    //    CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&DMA_SRC_BASE_2) , LO16((uint32)`$INSTANCE_NAME`_VDAC_Data_PTR));
    //#endif
    
    
    // either ControlReg or VDAC8
    CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&DMA_SRC_BASE_2) , LO16((uint32)`$INSTANCE_NAME`_Data_PTR));
    
    
    //CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);
    
    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    //CyDmaChEnable(DMA_Chan, 1);    // Enable DMA2 channel 
}    
*/   
//==============================================================================
// DMA Configuration
//==============================================================================
/*
void `$INSTANCE_NAME`_DMAConfigEx1(uint8 value) // phase shift
{
    // Variable declarations for DMA2
    //uint8_t DMA_Chan;
    //uint8_t DMA_TD[2];
    
    //#define TRANSFER_COUNT1 (`$INSTANCE_NAME`_NumRefHigh)
    //#define TRANSFER_COUNT2 (`$INSTANCE_NAME`_NumSamples - `$INSTANCE_NAME`_NumRefHigh)

    if (value==0) value=1; else if (value>=`$INSTANCE_NAME`_NumSamples) value = `$INSTANCE_NAME`_NumSamples - 1; // trim

    //#define TRANSFER_COUNT1a (value)
    //#define TRANSFER_COUNT2a (`$INSTANCE_NAME`_NumSamples - value)
    #define TRANSFER_COUNT1b (`$INSTANCE_NAME`_NumRefHigh)
    #define TRANSFER_COUNT2b (`$INSTANCE_NAME`_NumSamples - `$INSTANCE_NAME`_NumRefHigh)
    
    CyDmaChDisable(DMA_Chan);    // Disable DMA2 channel 
    CyDmaChFree(DMA_Chan);
    CyDmaClearPendingDrq(DMA_Chan);

    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    #define DMA_BYTES_PER_BURST     (1u)
    #define DMA_REQUEST_PER_BURST   (1u)
    
    #define DMA_SRC_BASE_1a (`$INSTANCE_NAME`_Buffer[0 + value])
    #define DMA_SRC_BASE_2a (`$INSTANCE_NAME`_Buffer[TRANSFER_COUNT1b + value])
    //#define DMA_DST_BASE (CYDEV_PERIPH_BASE)
    
    DMA_Chan = `$INSTANCE_NAME`_DMA2_DmaInitialize(DMA_BYTES_PER_BURST, DMA_REQUEST_PER_BURST, HI16(DMA_SRC_BASE_), HI16(DMA_DST_BASE));
    DMA_TD[0] = CyDmaTdAllocate();
	DMA_TD[1] = CyDmaTdAllocate();
    
    
    CyDmaTdSetConfiguration(DMA_TD[0], TRANSFER_COUNT1b, DMA_TD[1], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
	CyDmaTdSetConfiguration(DMA_TD[1], TRANSFER_COUNT2b, DMA_TD[0], TD_INC_SRC_ADR | `$INSTANCE_NAME`_DMA2__TD_TERMOUT_EN);
    
    
    // either ControlReg or VDAC8
    CyDmaTdSetAddress(DMA_TD[0], LO16((uint32)&DMA_SRC_BASE_1a) , LO16((uint32)`$INSTANCE_NAME`_Data_PTR));
    CyDmaTdSetAddress(DMA_TD[1], LO16((uint32)&DMA_SRC_BASE_2a) , LO16((uint32)`$INSTANCE_NAME`_Data_PTR));

    
    CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);
    
    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    CyDmaChEnable(DMA_Chan, 1);    // Enable DMA2 channel 
}  
*/

//==============================================================================
// Initialize component
//==============================================================================

void `$INSTANCE_NAME`_Initialize() 
{
    if (aInitialized) return;
    
    //todo: fill with some default values?
    //UpdateWave(Decoder_1_Position);       // fill Buffer with values
    
  
    `$INSTANCE_NAME`_DMAConfig();
    
    aInitialized = true;
}

//==============================================================================
// Resume DMA transfer
//==============================================================================

void `$INSTANCE_NAME`_Enable() 
{
    if (!aInitialized) return;
    if (aEnabled)      return; // comment in SW single shot
    

    CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);
    
    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1); // not synched with input strobe
    `$INSTANCE_NAME`_Count7_WriteCounter(1); // 

    `$INSTANCE_NAME`_Count7_Start();
        
    CyDmaChEnable(DMA_Chan, 1);// Enable DMA channel

    aEnabled = true;
}

//==============================================================================
// Initialize and start component
//==============================================================================

void `$INSTANCE_NAME`_Start(void) 
{
    `$INSTANCE_NAME`_Initialize();
    `$INSTANCE_NAME`_Enable();
}

//==============================================================================
// Stop component
// _Start() will begin from 0
//==============================================================================

void `$INSTANCE_NAME`_Stop(void) 
{

    if (!aInitialized) return;
    

    aEnabled = false;
    
    // disable DMA
    // To clear unwanted transfer requests (DRQ), issue a CPU terminate chain request
    //CyDmaChSetRequest(DMA_Chan, CPU_TERM_CHAIN); //CY_DMA_CPU_TERM_CHAIN 

    // Enable the DMA channel, This enable kills the spurious DMA transaction if there is one
    // and disables the channel, must re-enable
    //CyDmaChEnable(DMA_Chan, 1);
            
    //CyDmaClearPendingDrq(DMA_Chan);
            
    // re-enable the DMA channel
    //CyDmaChEnable(DMA_Chan, 1);

    //CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);           // prior to re-enabling the DMA channel.
    //CyDmaChEnable(DMA_Chan, 1);// Enable DMA channel

    
    // Stop and reset to start position->
    // To clear unwanted transfer requests (DRQ), issue a CPU terminate chain request
    CyDmaChSetRequest(DMA_Chan, CPU_TERM_CHAIN); //CY_DMA_CPU_TERM_CHAIN 
    
    CyDmaClearPendingDrq(DMA_Chan);
    //CyDmaChDisable(DMA_Chan);// Disable DMA channel
    
    //`$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    /*
    // stop DMA where it is
    CyDmaChDisable(DMA_Chan);// Disable DMA channel
    ///CyDmaChFree(DMA_Chan);
    ///CyDmaClearPendingDrq(DMA_Chan); // enable to start from 0, disable to continue
    */
    
    //VDAC only->
    //#if (!WaveGen_1_OUTP_DIGITAL_BUS)
    //   // `$INSTANCE_NAME`_VDAC_Stop();        // Goes into HiZ state
    //                                           // keeps last voltage 
    //#endif
    
    `$INSTANCE_NAME`_Count7_Stop(); // disable counter
    
}


//==============================================================================
// Pause DMA transfer
//==============================================================================

void `$INSTANCE_NAME`_Disable() 
{
    if (!aInitialized) return;
    if (!aEnabled)     return;
    
    aEnabled = false;
    
    CyDmaChDisable(DMA_Chan);// Disable DMA channel
    
   // `$INSTANCE_NAME`_ControlReg_Reset_Write(1);
    
    //VDAC only->
    //#if (!WaveGen_1_OUTP_DIGITAL_BUS)
    //   // `$INSTANCE_NAME`_VDAC_Stop();        // Goes into HiZ state 
    //#endif
    
}

//==============================================================================
// reset DMA to start
//==============================================================================

void  `$INSTANCE_NAME`_Reset()                
{
            /*
            //not required->
            // To clear unwanted transfer requests (DRQ), issue a CPU terminate chain request
            //CyDmaChSetRequest(DMA_Chan, CPU_TERM_CHAIN);

            // Enable the DMA channel, This enable kills the spurious DMA transaction if there is one
            // and disables the channel, must re-enable
            //CyDmaChEnable(DMA_Chan, 1);
            
            //CyDmaClearPendingDrq(DMA_Chan);
            
            // re-enable the DMA channel
            //CyDmaChEnable(DMA_Chan, 1);

            //CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);           // prior to re-enabling the DMA channel.
            //CyDmaChEnable(DMA_Chan, 1);// Enable DMA channel
            */
    
    //CyDmaChDisable(DMA_Chan);// Disable DMA channel
    //CyDmaChFree(DMA_Chan);
    //CyDmaClearPendingDrq(DMA_Chan);

}

//==============================================================================
// Get enabled status
//==============================================================================

__INLINE uint8 `$INSTANCE_NAME`_GetEnabled() 
{
    return aEnabled;
}

//==============================================================================
// Get Buffer state 
// returns 1 if first (high state) half-buffer is completed,
//         0 if second (low state) half-buffer is completed
//
// Use this flag in drq interrupt to determine which half buffer is completed
//==============================================================================

__INLINE uint8 `$INSTANCE_NAME`_GetBufferState() 
{
    return (`$INSTANCE_NAME`_Count7_ReadCounter() == 1)? 0 : 1;
}

//==============================================================================
// Get half-Buffer offset
// returns position offset of the first or second half buffer, 
// whichever has completed recently:
// 0          - first (high state) half-buffer,
// NumRefHigh - second (low state) half-buffer
//==============================================================================

__INLINE uint16 `$INSTANCE_NAME`_GetBufferOffset() 
{
    return (`$INSTANCE_NAME`_Count7_ReadCounter() == 0)? 0 : `$INSTANCE_NAME`_NumRefHigh;
}








//==============================================================================
// END OF FILE
//==============================================================================

/*
volatile CYBIT flag_Capture = 0; 
CY_ISR(myCaptureInt)                //interrupt on "nrq" rising edge
{   
    if (!Capture) return; // disable interrupt while processing
    Capture = 0;
    
    flag_Capture = 1;
    
    CyDmaChDisable(DMA_Chan);// Disable DMA channel
    CyDmaChFree(DMA_Chan);
    CyDmaClearPendingDrq(DMA_Chan);
    //CyDmaChFree(DMA_Chan);
            
            
            /// To clear unwanted transfer requests (DRQ), issue a CPU terminate chain request
            ///CyDmaChSetRequest(DMA_Chan, CPU_TERM_CHAIN);
            //CyDmaChSetRequest(DMA_Chan, CY_DMA_CPU_TERM_CHAIN);
            ///CyDmaChSetRequest(DMA_Chan, CY_DMA_CPU_TERM_TD); // Terminate the TD 
    

            /// Enable the DMA channel, This enable kills the spurious DMA transaction if there is one
            /// and disables the channel, must re-enable
            //CyDmaChEnable(DMA_Chan, 1);
            
    
    
    //CyDmaChSetRequest(DMA_Chan, CY_DMA_CPU_TERM_TD); // Terminate the entire chain of TD's 
    //while(CyDmaChGetRequest(DMA_Chan));                 // Wait for the request to be processed. CYRET_SUCCESS 
    //CyDmaChSetInitialTd(DMA_Chan, DMA_TD[0]);           // prior to re-enabling the DMA channel.
    //CyDmaChEnable(DMA_Chan, 1);                       // Re-enable the DMA channel.

    //BlinkLED();   // completion indicator
    //CaptureCnt++;
}
*/

/* [] END OF FILE */
